# -*- coding: utf-8 -*-
from setuphelpers import *

try:
    import bs4 as BeautifulSoup
except:
    import BeautifulSoup
import platform
import requests

# Defining variables
bin_contains = "virtualbox"
# bin_ext_name_string = 'Oracle_VM_VirtualBox_Extension_Pack-%s.vbox-extpack'
# bin_ext_name_joker = '*.vbox-extpack'


def install():
    bin_name = glob.glob("*%s*.deb" % bin_contains)[0]

    # Installing the package
    print("Installing: %s" % bin_name)
    install_deb(bin_name)


#    #Installing the VirtualBox Extension Pack
#    for ext in glob.glob(bin_ext_name_joker):
#        print('Installing: %s' % ext)
#        try:
#            run('echo y | VBoxManage extpack install --replace "%s"' % ext)
#        except:
#            run('VBoxManage extpack cleanup ')
#            run('echo y | VBoxManage extpack install --replace "%s"' % ext)


def uninstall():
    package_name = "virtualbox*"

    # Uninstalling the package
    print("Uninstalling: %s" % package_name)
    uninstall_apt(package_name)


def update_package():
    # Getting proxy informations from WAPT settings
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()

    distri = control.target_os.split("-")[1].lower()

    # Specific app values
    url = "https://www.virtualbox.org/wiki/Linux_Downloads"

    # Getting latest version from official website

    for u in bs_find_all(url, "a", "class", "ext-link", proxies=proxies):
        if ".deb" in str(u["href"]) and distri in str(u["href"]).lower():
            url_dl = u["href"]
            latest_bin = url_dl.split("/")[-1]
            version = url_dl.split("/")[-2]
    #            latest_bin_ext = bin_ext_name_string % version
    #            url_dl_ext = url_dl.replace(latest_bin,latest_bin_ext)

    print("Latest Version %s" % version)

    for f in glob.glob("*.deb"):
        if f != latest_bin:
            remove_file(f)

    # Downloading latest binaries
    if not isfile(latest_bin):
        print("Downloading: " + latest_bin)
        wget(url_dl, latest_bin, proxies=proxies)

    # Downloading extension
    #    if not isfile(latest_bin_ext):
    #        print("Downloading: %s" % latest_bin_ext)
    #        wget(url_dl_ext, latest_bin_ext, proxies=proxies)

    # Changing version of the package
    control.version = "%s-%s" % (version, control.version.split("-", 1)[-1])
    control.save_control_to_wapt()
    print("Changing package version to: %s in WAPT\\control" % control.version)
